using System;
using System.Collections.Generic;
using System.Text;
using LibJasinski.Network;
using System.Text.RegularExpressions;

namespace DesktopText
{
	class VerseGetter2 : WebScraper
	{
		private static VerseGetter2 _default;
		static VerseGetter2()
		{
			_default = new VerseGetter2();
		}
		public static VerseGetter2 Default
		{
			get { return _default; }
		}

		private string _verse = "";
		private string _reference = "";

		public string Verse
		{
			get {return _verse; }
		}

		public string Reference
		{
			get { return _reference; }
		}

		public bool Get()
		{
			string url = Cfg.Def.SourceUrl;
			string pattern = Cfg.Def.RegexPattern;
			bool result = false;
			
			if (base.Get(url, pattern))
			{
				MatchCollection mc = base.Matches;
				if (mc.Count > 0)
				{
					_verse = InsertLineBreaks(mc[0].Groups["verse"].Value.Trim());
					_reference = mc[0].Groups["reference"].Value.Trim();
					result = _verse.Length > 0 & _reference.Length > 0;
				}
			}

			return result;
		}
		private string InsertLineBreaks(string input)
		{
			int maxLineLength = 100;
			int lineLength = 0;
			string result = "";
			string[] words = input.Split(new char[] {' '});

			for (int i = 0; i <= words.GetUpperBound(0); i++)
			{
				if (lineLength + words[i].Length > maxLineLength)
				{
					lineLength = 0;
					result += Environment.NewLine;
				}
				lineLength += words[i].Length + 1;
				result += words[i];
				result += " ";
			}
			return result;
		}
	}
}
